## minexpert2 9.2.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.18.4)

############################################################
############################################################
# Basic information about project

project(mineXpert2
  DESCRIPTION "A program to visualize and explore mass spectrometric data"
  HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")

set(LOWCASE_PROJECT_NAME minexpert2)

set(VERSION 9.2.0)

# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2023 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects 
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")


# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
  )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall -pedantic.${ColourReset}")
add_definitions(-Wall -pedantic)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message("${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

  if(MXE)

    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

  elseif(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(UNIX)

  #message("UNIX")

  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
  # need to be installed and they ship the PappsoMSppConfig.cmake
  # config file.

  # However, when developing both libs and this program, we need to be able to
  # load the libs from their dev/build directory without relying on the system
  # libs (add -DLOCAL_DEV=1).
  if(LOCAL_DEV)
    # The development should use the locally built libs.
    message("Using the local libpappsomspp libraries.")
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
  else()
    # The development should use the system-wide libs.
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

  endif()

  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
  message(STATUS "PappsoMSpp and PappsoMSppWidget were found:
  \t${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


# OPENMP
message(STATUS "${BoldYellow}OpenMP support is compulsory.${ColourReset}")
if(NOT OpenMP_FOUND)
  include(FindOpenMP)
  if(OpenMP_FOUND)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  else()
    message(STATUS "ERROR: OpenMP could not be found.")
  endif()
endif()


if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
  add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
  ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX)
  execute_process(COMMAND inkscape
    ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg -o
    ${CMAKE_SOURCE_DIR}/images/splashscreen.png -w 600)
endif()

#############################################################
##################
# BUILD OF LIBMASS

message(STATUS "Adding subdirectory libmass for TARGET: ${TARGET}")
add_subdirectory(libmass)

#############################################################
#####################
# BUILD OF LIBMASSGUI

message(STATUS "Adding subdirectory libmassgui for TARGET: ${TARGET}")
add_subdirectory(libmassgui)

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)

#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
message(STATUS "Adding subdirectory doc for project: ${TARGET}")
add_subdirectory(doc)

#############################################################
####################
# BUILD OF THE TESTS
if(MAKE_TESTS)
  #MESSAGE("MAKE_TEST was set to ${MAKE_TEST}")
  enable_testing()
  include(CTest)

  if(BUILD_TESTING)

    add_subdirectory(tests)

  endif(BUILD_TESTING)

endif()


# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
configure_file(${CMAKE_UTILS_PATH}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)


#############################################################
#############################################################
# Installation prefix
if (NOT CMAKE_INSTALL_PREFIX)
  SET (CMAKE_INSTALL_PREFIX /usr/local)
endif (NOT CMAKE_INSTALL_PREFIX)


####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "BIN_DIR: ${BIN_DIR}")
message(STATUS "DOC_DIR: ${DOC_DIR}")


#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(archive
  cpack -G TGZ --config CPackSourceConfig.cmake && mv
  ${CMAKE_BINARY_DIR}/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../tarballs && ln -sf
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../${LOWCASE_PROJECT_NAME}_${VERSION}.orig.tar.gz && ln -sf
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}_${VERSION}.orig.tar.gz

  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  COMMENT "Creating .tar.gz" VERBATIM
)





#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}BIN_DIR: ${BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}DOC_DIR: ${DOC_DIR}${ColourReset}")

if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(WARNASERR)
  message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
  message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}") 
message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}") 
message("")

if(LOCAL_DEV)
  message("")

## minexpert2 9.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 set(LOWCASE_PROJECT_NAME minexpert2)
 
-set(VERSION 9.2.0)
+set(VERSION 9.2.1)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")

=== src/CMakeLists.txt ===
message(\n${BoldRed}"Now configuring src/ for ${TARGET}"${ColourReset}\n)


########################################################
# Files
set(${TARGET}_nongui_SRCS
  #
  # Some globals.
  nongui/globals.cpp
  #
  # The main class that hold the mass data.
  nongui/MsRunDataSet.cpp
  #
  # The class to handle the statistics computation about a given MsRunDataSet.
  nongui/MsRunDataSetStats.cpp

  nongui/MassSpecDataFileLoader.cpp
  #
  # The classe that monitors integrators.
  nongui/MassDataIntegratorTask.cpp
  #
  # The base class of the integrators.
  nongui/MassDataIntegrator.cpp
  #
  # The various integrators that use BaseMsRunDataSetTreeNodeVisitor.
  nongui/MsRunDataSetTreeMassDataIntegratorToRt.cpp
  #
  # The various MsRunDataSetTreeNodeVisitor classes.
  nongui/BaseMsRunDataSetTreeNodeVisitor.cpp
  nongui/MsRunStatisticsTreeNodeVisitor.cpp
  nongui/TicChromTreeNodeCombinerVisitor.cpp
  nongui/TicChromatogramFromMassSpecDataFile.cpp
  nongui/MultiTreeNodeCombinerVisitor.cpp
  #
  # The various integrators that use QualifiedMassSpectrumVector.
  nongui/QualifiedMassSpectrumVectorMassDataIntegrator.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToTicInt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDtRtMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRtDt.cpp
  #
  # The classes that handle the processing flow
  nongui/ProcessingFlow.cpp
  nongui/ProcessingStep.cpp
  nongui/ProcessingType.cpp
  #
  # The classes that handle the parameters for the various integrations and the
  # display of traces.
  nongui/MsFragmentationSpec.cpp
  #
  # Analysis preferences
  nongui/AnalysisPreferences.cpp
)

set(${TARGET}_gui_SRCS
  gui/Application.cpp
  gui/ProgramWindow.cpp
  gui/MsRunSelectorDlg.cpp
  gui/AboutDlg.cpp
  #
  gui/ConsoleWnd.cpp
  #
  gui/MsRunReadTask.cpp
  #
  gui/OpenMsRunDataSetsDlg.cpp
  #
  gui/TaskMonitorCompositeWidget.cpp
  gui/TaskMonitorWnd.cpp
  #
  # The ms run data set tree view classes
  gui/MsRunDataSetTableViewWnd.cpp
  gui/MsRunDataSetTableViewItem.cpp
  gui/MsRunDataSetTableView.cpp
  gui/MsRunDataSetTableViewModel.cpp
  gui/MsRunDataSetTableViewProxyModel.cpp
  #	
  # The MS fragmentation specification dialog
  gui/MsFragmentationSpecDlg.cpp
  #
  # The M/Z integration parameters dialog
  gui/MzIntegrationParamsDlg.cpp
  #
  # The Savitzky-Golay filter params dialog
  gui/SavitzkyGolayFilterParamsDlg.cpp
  #
  # The data plot graph/widget tree classes
  gui/DataPlottableNode.cpp
  gui/DataPlottableTree.cpp
  #
  # The trace plot widgets derived from pappso::BaseTracePlotWidget
  gui/TicXicChromTracePlotWidget.cpp
  gui/MassSpecTracePlotWidget.cpp
  gui/DriftSpecTracePlotWidget.cpp
  #
  # The trace plot composite widgets
  gui/BasePlotCompositeWidget.cpp
  gui/BaseTracePlotCompositeWidget.cpp
  gui/TicXicChromTracePlotCompositeWidget.cpp
  gui/MassSpecTracePlotCompositeWidget.cpp
  gui/DriftSpecTracePlotCompositeWidget.cpp
  #
  # The color map plot composite widgets
  gui/BaseColorMapPlotCompositeWidget.cpp
  gui/TicXicChromMassSpecColorMapPlotCompositeWidget.cpp
  gui/TicXicChromDriftSpecColorMapPlotCompositeWidget.cpp
  gui/DriftSpecMassSpecColorMapPlotCompositeWidget.cpp
  #
  # The plot windows
  gui/BasePlotWnd.cpp
  #	
  # Trace plot windows
  gui/BaseTracePlotWnd.cpp
  gui/BaseColorMapPlotWnd.cpp
  gui/TicXicChromTracePlotWnd.cpp
  gui/MassSpecTracePlotWnd.cpp
  gui/DriftSpecTracePlotWnd.cpp
  #
  # Color map plot windows
  gui/TicXicChromMassSpecColorMapWnd.cpp
  gui/TicXicChromDriftSpecColorMapWnd.cpp
  gui/DriftSpecMassSpecColorMapWnd.cpp
  #
  # The save plot to graphics file
  gui/SaveToGraphicsFileDlg.cpp
  #
  # The ProcessingFlow viewer dialog window
  gui/ProcessingFlowViewerDlg.cpp
  #
  # The XIC chromatogram feature
  gui/XicExtractionWnd.cpp
  #
  # Analysis preferences
  gui/AnalysisPreferencesDlg.cpp
  #
  # Labelled widget-based QAction classes
  gui/LabelledDoubleSpinBoxAction.cpp
  gui/LabelledNumberLineEditAction.cpp
  #
  # Plot overlay transparent widget
  gui/PlotAreaOverlay.cpp
)

set(${TARGET}_UIS
  gui/ui/AboutDlg.ui
  gui/ui/MsRunSelectorDlg.ui
  gui/ui/OpenMsRunDataSetsDlg.ui
  gui/ui/MsRunDataSetTableViewWnd.ui
  gui/ui/BasePlotWnd.ui
  gui/ui/BasePlotCompositeWidget.ui
  gui/ui/TaskMonitorCompositeWidget.ui
  gui/ui/TaskMonitorWnd.ui
  gui/ui/ConsoleWnd.ui
  gui/ui/MsFragmentationSpecDlg.ui
  gui/ui/MzIntegrationParamsDlg.ui
  gui/ui/SavitzkyGolayFilterParamsDlg.ui
  gui/ui/SaveToGraphicsFileDlg.ui
  gui/ui/ProcessingFlowViewerDlg.ui
  gui/ui/XicExtractionWnd.ui
  gui/ui/AnalysisPreferencesDlg.ui
  gui/ui/ScriptingWnd.ui
)

qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt6_add_resources(${TARGET}_QRC_CPP ../${LOWCASE_PROJECT_NAME}.qrc)

# Instruct CMake to run automatically when needed the following:
set(CMAKE_AUTOMOC ON) # For meta object compiler
set(CMAKE_AUTORCC ON) # Resource files

include_directories(

  # The config file is binary directory-specific !!!
  # For the config.h file generated from config.h.in
  # For the ui_Xyyyyy.h files
  ${CMAKE_CURRENT_BINARY_DIR}

  # For all the source subdirectories
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
)


###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(WIN32 OR _WIN32)

  add_executable(${TARGET}
    main.cpp
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

  # In Debug mode we want the console to be opened so that we can read the debug
  # messages. But in Release mode the console is not desirable (the snippet
  # below removes it).
  if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set_property(TARGET ${TARGET} PROPERTY WIN32_EXECUTABLE true)
  endif()

elseif(UNIX)

  add_executable(${TARGET}
    main.cpp
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

endif()


# Finally actually set the linking dependencies to the executable.
# Note that there are so many cross-dependencies that it is virtually unfeasible
# to actually link the binary without resorting to the linker dance steps below.

# Still, I discovered that the order below is good with respect of the symbols
# dependencies resolutions when linking

# The general idea is to first list the libraries that *use* symbols and later
# libraries that *provide* symbols. Which is why all the Qt libs are listed at
# the end and the private libs are listed first.
target_link_libraries(${TARGET}

  -Wl,--whole-archive
  libmass::nongui
  libmass::gui
  -Wl,--no-whole-archive

  -Wl,--no-as-needed
  PappsoMSpp::Core
  PappsoMSpp::Widget
  -Wl,--as-needed

  -Wl,--no-as-needed
  IsoSpec++::IsoSpec++
  -Wl,--as-needed

  QCustomPlotQt6::QCustomPlotQt6
  QuaZip::QuaZip

  Qt6::Widgets
  Qt6::Svg
  Qt6::PrintSupport
  Qt6::Xml
  Qt6::Network
)


if(PROFILE)
  message(STATUS "Profiling is requested, adding linker -pg flag.")
  set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

# We want to install the binary arch-dependent target in
# specific situations. To have proper control, we define the arch
# component.
install(TARGETS ${TARGET}
  RUNTIME
  COMPONENT arch
  DESTINATION ${BIN_DIR})


message("")
message(STATUS "${BoldGreen}Finished configuring of ${TARGET}.${ColourReset}")
message("")

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)

  if(UNIX AND NOT APPLE)

    message("")
    message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
    message("")

    # The version of the program needs to be set in the user manual front
    # matter.
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.in
      ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)

    # The location of the main user manual config file (set fop.xconf file
    # location)
    set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
      ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)

    # Command:
    # make usermanual
    # Makes use of the local  Makefile file.
    # Will generate HTML and PDF documentation in the build directory

    message("\tConfiguring the user manual compilation")

    add_custom_target(usermanual
      COMMAND make -f usermanual-makefile all_f
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Build of the DocBook-based user manual documentation")

    install(FILES
      ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/${TARGET}-doc.pdf
      DESTINATION ${DOC_DIR})

    install(DIRECTORY 
      ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/html/user-manual/
      DESTINATION ${DOC_DIR}/html)

    message("")
    message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
    message("")

  else()

    message(STATUS "User manual build skipped")

  endif()

endif()

=== debian/changelog ===
minexpert2 (9.2.1-1) unstable; urgency=medium

  * Upstream release 

    - a serious bug has been fixed (not removing mass spectra from the set to
    be integrated based on the DT range; commit
    df32744d79564f477c7f2358f7681adb5373cb59).

    - improvements to the GUI (added syntax-explanating tooltips to the mass
    spectral data table view filtering line edit widgets)

    - fixed small memory leaks

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 30 Jun 2023 10:51:55 +0200

minexpert2 (9.2.0-1) unstable; urgency=low

  * New upstream release with improvements in the way plots are exported 
    as graphics files or as a clipboard object (SVG or RASTER).

  * Update dep lib version libpappsomspp-dev (>= 0.9.12).

  * Removed a bunch of dep pacakges versions.

  * Standards-Version: 4.6.2

  * Remove Conflicts: msxpertsuite-minexpert-data-doc and co.

  * Should fix the build failure (Closes: #1037777).

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 20 Jun 2023 16:56:43 +0200

minexpert2 (9.1.0-1) unstable; urgency=low

  * Version 9.0.0 was not published.
  * New upstream release with improvements.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 13 May 2023 19:37:17 +0200

=== debian/control ===
Source: minexpert2
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper (>= 13.3.4),
 dpkg-dev (>= 1.21.22),
# To export from svg to png
 inkscape,
 libgomp1,
 qt6-base-dev,
 libqt6svg6-dev,
 libqt6core5compat6-dev,
 cmake,
 daps,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra,
 fonts-ebgaramond-extra,
 fonts-urw-base35,
 libqcustomplot-dev,
 libisospec++-dev,
 libquazip1-qt6-dev,
 zlib1g-dev,
 libpappsomspp-dev (>= 0.9.12),
 libpappsomspp-widget-dev (>= 0.9.12),
 docbook-xml,
 docbook-to-man
Standards-Version: 4.6.2
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert2
Vcs-Git: https://salsa.debian.org/debichem-team/minexpert2.git
Rules-Requires-Root: no

Package: minexpert2
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: minexpert2-doc (>= ${source:Upstream-Version})
Description: MS^n mass spectrometric data visualization and mining (runtime)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data 
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a 
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the 
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based 
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric 
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the mineXpert2 program.


Package: minexpert2-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Description: MS^n mass spectrometric data visualization and mining (doc)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data 
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a 
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the 
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based 
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric 
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the user manual in both PDF and HTML formats.

## minexpert2 9.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 set(LOWCASE_PROJECT_NAME minexpert2)
 
-set(VERSION 9.2.1)
+set(VERSION 9.2.2)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
@@ -236,22 +236,6 @@
 message(STATUS "Adding subdirectory doc for project: ${TARGET}")
 add_subdirectory(doc)
 
-#############################################################
-####################
-# BUILD OF THE TESTS
-if(MAKE_TESTS)
-  #MESSAGE("MAKE_TEST was set to ${MAKE_TEST}")
-  enable_testing()
-  include(CTest)
-
-  if(BUILD_TESTING)
-
-    add_subdirectory(tests)
-
-  endif(BUILD_TESTING)
-
-endif()
-
 
 # Use all the configured paths to create the config.h file.
 # The config file is binary directory-specific !!!
@@ -343,3 +327,10 @@
 
 if(LOCAL_DEV)
   message("")
+  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR PAPPSOMSPP")
+  message("")
+endif()
+
+message("")
+message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
+message("")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,8 @@
   #
   gui/TaskMonitorCompositeWidget.cpp
   gui/TaskMonitorWnd.cpp
+  #
+  gui/TicChromPreviewerMassDataLoadDlg.cpp 
   #
   # The ms run data set tree view classes
   gui/MsRunDataSetTableViewWnd.cpp
@@ -160,6 +162,7 @@
   gui/ui/XicExtractionWnd.ui
   gui/ui/AnalysisPreferencesDlg.ui
   gui/ui/ScriptingWnd.ui
+  gui/ui/TicChromPreviewerMassDataLoadDlg.ui
 )
 
 qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})
@@ -256,6 +259,7 @@
   Qt6::PrintSupport
   Qt6::Xml
   Qt6::Network
+  Qt6::Sql
 )

## minexpert2 9.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 set(LOWCASE_PROJECT_NAME minexpert2)
 
-set(VERSION 9.2.2)
+set(VERSION 9.3.1)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The UNIX man pages
if(UNIX)

	message(STATUS "Going to generate the man pages.")

	execute_process(COMMAND docbook-to-man minexpert2.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/minexpert2.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif(UNIX)


###############
# install stuff

# The history and licence files.

message("Installing the doc files in ${DOC_DIR}")
install(FILES history.html ../LICENSE
	DESTINATION ${DOC_DIR})

# The man page.
if(UNIX)
	install(FILES ${CMAKE_BINARY_DIR}/minexpert2.1
		${CMAKE_BINARY_DIR}/minexpert2.1
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUALS

if(BUILD_USER_MANUAL)
	add_subdirectory(user-manual)
endif()


message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,12 +8,17 @@
   # Some globals.
   nongui/globals.cpp
   #
+  # The classes to look into an MS run prior to loading it
+  nongui/MsRunProber.cpp
+  nongui/vendor/BrukerTimsTofMsRunProber.cpp
+  #
   # The main class that hold the mass data.
   nongui/MsRunDataSet.cpp
   #
   # The class to handle the statistics computation about a given MsRunDataSet.
   nongui/MsRunDataSetStats.cpp
-
+  #
+  # The class to load MS run data
   nongui/MassSpecDataFileLoader.cpp
   #
   # The classe that monitors integrators.
@@ -63,13 +68,14 @@
   gui/ConsoleWnd.cpp
   #
   gui/MsRunReadTask.cpp
+  gui/MsRunProbeTask.cpp
   #
   gui/OpenMsRunDataSetsDlg.cpp
   #
   gui/TaskMonitorCompositeWidget.cpp
   gui/TaskMonitorWnd.cpp
   #
-  gui/TicChromPreviewerMassDataLoadDlg.cpp 
+  gui/MsRunProbeInfoViewerDlg.cpp 
   #
   # The ms run data set tree view classes
   gui/MsRunDataSetTableViewWnd.cpp
@@ -162,7 +168,7 @@
   gui/ui/XicExtractionWnd.ui
   gui/ui/AnalysisPreferencesDlg.ui
   gui/ui/ScriptingWnd.ui
-  gui/ui/TicChromPreviewerMassDataLoadDlg.ui
+  gui/ui/MsRunProbeInfoViewerDlg.ui
 )
 
 qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)

  if(UNIX)

    message("")
    message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
    message("")

    # Start by copying the whole user manual directory to the build directory
    file(COPY ${CMAKE_SOURCE_DIR}/doc/user-manual DESTINATION ${CMAKE_BINARY_DIR}/doc/)

    # The version of the program needs to be set in the user manual front
    # matter.
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.in
      ${CMAKE_BINARY_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)

    # The location of the main user manual config file (set fop.xconf file
    # location)
    set(FOP_XCONF_DIR ${CMAKE_BINARY_DIR}/doc/user-manual)
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
      ${CMAKE_BINARY_DIR}/doc/user-manual/DC-user-manual @ONLY)

    # Command:
    # make usermanual
    # Makes use of the local  Makefile file.
    # Will generate HTML and PDF documentation in the build directory

    message("\tConfiguring the user manual compilation")

    add_custom_target(usermanual
      COMMAND make -f usermanual-makefile all_f
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/doc/user-manual
      COMMENT "Build of the DocBook-based user manual documentation")

    install(FILES
      ${CMAKE_BINARY_DIR}/doc/user-manual/build/user-manual/${TARGET}-doc.pdf
      DESTINATION ${DOC_DIR})

    install(DIRECTORY 
      ${CMAKE_BINARY_DIR}/doc/user-manual/build/user-manual/html/user-manual/
      DESTINATION ${DOC_DIR}/html)

    message("")
    message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
    message("")

  else()

    message(STATUS "User manual build skipped")

  endif()

endif()

=== debian/changelog ===
minexpert2 (9.3.1-1) unstable; urgency=low

  * New upstream version improving the probing of the Bruker timsTOF data
    prior to loading.

  * libpappsomspp-dev (>= 0.9.20)

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 05 Dec 2023 11:43:17 +0100

minexpert2 (9.2.2-1) unstable; urgency=low

  * Fix bug: minexpert2: Fails to build source after successful build. Running
    dpkg-buildpackage; dpkg-buildpackage -S works flawlessly (Closes:
    #1046641). Thanks Lucas Nussbaum for reporting the bug.

  * Update dependency over libpappsomspp*.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 20 Nov 2023 18:12:24 +0100

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
  qt6-base-dev,
  libqt6svg6-dev,
  libqt6core5compat6-dev,
+ libxkbcommon-x11-dev,
  cmake,
  daps,
  libjs-jquery,
@@ -22,8 +23,8 @@
  libisospec++-dev,
  libquazip1-qt6-dev,
  zlib1g-dev,
- libpappsomspp-dev (>= 0.9.12),
- libpappsomspp-widget-dev (>= 0.9.12),
+ libpappsomspp-dev (>= 0.9.20),
+ libpappsomspp-widget-dev (>= 0.9.20),
  docbook-xml,
  docbook-to-man
 Standards-Version: 4.6.2

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Include for DEB_VERSION_UPSTREAM below
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp
	rm -f libmass/libmass.a
	rm -f libmassgui/libmassgui.a
	rm -f compile_commands.json

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

	# Ensure that the fop.xconf file is found in the DC* files
	# that are located in $(CURDIR)/doc/user-manual

	cd debian/build/doc/user-manual && \
		sed -i 's|/home/rusconi/devel/minexpert2/development/doc/user-manual/fop.xconf|debian/build/doc/user-manual/fop.xconf|' DC-user-manual

override_dh_auto_build:
	cd debian/build && make
	cd debian/build && make usermanual

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install
